
void fadeoff_update (void)

{

  current_millis = millis();

  global_hue_ref = ((current_millis & color_period_minus_1) << 12) >> color_period_BS;

  byte red[12] = {0,0,0,0,0,0,0,0,0,0,0,0};
  byte green[12] = {0,0,0,0,0,0,0,0,0,0,0,0};
  byte blue[12] = {0,0,0,0,0,0,0,0,0,0,0,0};
  byte color_component;
  int hue;
  byte brightness;

  if (DMX_fixtures_curve)
  {
    for (byte drum_number0thru11 = 0; drum_number0thru11 < 12; drum_number0thru11++)
    {
      for (byte light_number0thru11 = 0; light_number0thru11 < 12; light_number0thru11++)
      {

        if (current_brightness_index[drum_number0thru11][light_number0thru11])

        {
          current_brightness_index[drum_number0thru11][light_number0thru11] = fadeoff_map(current_millis, start_millis[drum_number0thru11][light_number0thru11], end_millis[drum_number0thru11][light_number0thru11], start_brightness_index[drum_number0thru11][light_number0thru11], pgm_read_byte(&(bitshift[drum_number0thru11])));

          hue = (global_hue_ref + (current_brightness_index[drum_number0thru11][light_number0thru11] << fadeoff_color_change_BS) + pgm_read_word(&(hue_offset[drum_number0thru11]))) & 0xFFF;

          color_component = HB2red(hue, current_brightness_index[drum_number0thru11][light_number0thru11]);
          if (color_component > red[light_number0thru11])
          {
            red[light_number0thru11] = color_component;
          }

          color_component = HB2green(hue, current_brightness_index[drum_number0thru11][light_number0thru11]);
          if (color_component > green[light_number0thru11])
          {
            green[light_number0thru11] = color_component;
          }

          color_component = HB2blue(hue, current_brightness_index[drum_number0thru11][light_number0thru11]);
          if (color_component > blue[light_number0thru11])
          {
            blue[light_number0thru11] = color_component;
          }
        }
      }
    }
  }
  else
  {
    for (byte drum_number0thru11 = 0; drum_number0thru11 < 12; drum_number0thru11++)
    {
      for (byte light_number0thru11 = 0; light_number0thru11 < 12; light_number0thru11++)
      {

        if (current_brightness_index[drum_number0thru11][light_number0thru11])

        {
          current_brightness_index[drum_number0thru11][light_number0thru11] = fadeoff_map(current_millis, start_millis[drum_number0thru11][light_number0thru11], end_millis[drum_number0thru11][light_number0thru11], start_brightness_index[drum_number0thru11][light_number0thru11], pgm_read_byte(&(bitshift[drum_number0thru11])));

          hue = (global_hue_ref + (current_brightness_index[drum_number0thru11][light_number0thru11] << fadeoff_color_change_BS) + pgm_read_word(&(hue_offset[drum_number0thru11]))) & 0xFFF;

          brightness = curve[current_brightness_index[drum_number0thru11][light_number0thru11]];

          color_component = HB2red(hue, brightness);
          if (color_component > red[light_number0thru11])
          {
            red[light_number0thru11] = color_component;
          }

          color_component = HB2green(hue, brightness);
          if (color_component > green[light_number0thru11])
          {
            green[light_number0thru11] = color_component;
          }

          color_component = HB2blue(hue, brightness);
          if (color_component > blue[light_number0thru11])
          {
            blue[light_number0thru11] = color_component;
          }
        }
      }
    }
  }

  setRGB(0, red[0], green[0], blue[0]);
  setRGB(1, red[1], green[1], blue[1]);
  setRGB(2, red[2], green[2], blue[2]);
  setRGB(3, red[3], green[3], blue[3]);
  setRGB(4, red[4], green[4], blue[4]);
  setRGB(5, red[5], green[5], blue[5]);
  setRGB(6, red[6], green[6], blue[6]);
  setRGB(7, red[7], green[7], blue[7]);
  setRGB(8, red[8], green[8], blue[8]);
  setRGB(9, red[9], green[9], blue[9]);
  setRGB(10, red[10], green[10], blue[10]);
  setRGB(11, red[11], green[11], blue[11]);
  leds.show();

}


