
byte fadeoff_map(long now, long start_millis, long end_millis, byte start_brightness_index, byte BS)
{
  
  if (now > end_millis) {return 0;}

  long brightness_index;

  if (velocity_sensitive_sustain)
  {
  brightness_index = start_brightness_index - (((now - start_millis) << 8) >> BS);
  }
  
  else
  {
  brightness_index = start_brightness_index - ((start_brightness_index * (now - start_millis)) >> BS);
  }
  
  if (brightness_index > 0) {return (byte)(brightness_index);}
  else {return 0;}
  
}


